<?php

use App\Base\Base;

use App\Models\order\mysql\PayOrder;
use App\Services\pay\PayService;
use App\Services\refund\RefundService;
use App\Models\order\mysql\CallbackLog;
use App\Services\pingxx\PingxxService;

class CallbackController extends Base
{
    /**
     * 创建支付订单，返回前端ping++的支付信息
     */
    public function payAction()
    {
        try{

            $raw_data = file_get_contents('php://input');

            $paySrv = new PayService();

            $data = json_decode($raw_data, true);

            /**/
            if(!empty($data['data']['object'])) {
                CallbackLog::insert([
                    'type'=>$data['type'] ?? '',
                    'merchant_order_no'=>$data['data']['object']['merchant_order_no'] ?? '',
                    'object_id'=>$data['data']['object']['id'] ?? '',
                    'data'=>base64_encode(gzcompress($raw_data)), //压缩存储
                ]);
            }
            //$str = gzuncompress(base64_decode($info['data']));

            $ret = $paySrv->call_back($data);
            $this->success(['result'=>$ret]);

        }catch (Exception $e) {
            throw $e;
            $this->failed('500', $e->getMessage());
        }
    }

    public function refundAction() {

        try{
            $raw_data = file_get_contents('php://input');
            $data = json_decode($raw_data, true);

            if(!empty($data['data']['object'])) {
                CallbackLog::insert([
                    'type'=>$data['type'] ?? '',
                    'merchant_order_no'=>$data['data']['object']['merchant_order_no'] ?? '',
                    'object_id'=>$data['data']['object']['id'] ?? '',
                    'data'=>base64_encode(gzcompress($raw_data)), //压缩存储
                ]);
            }

            $refundSrv = new RefundService();
            $ret = $refundSrv->call_back($data);
            $this->success(['result'=>$ret]);

        }catch (Exception $e) {
            $this->failed('500', $e->getMessage());
        }
    }
}
